import swarm.objectbase.*;
import swarm.defobj.*;
import swarm.space.*;
import swarm.gui.*;
import java.util.*;

public class Bee extends SwarmObjectImpl {
	//sFtimes of not overwritten
	//xPos,yPos position
	//xMax [-xMax,xMax]
	//worldXSize,worldYSize window size
	//fit fitness
	//p probability for roulette
	public int s=0;
	public double xPos,yPos,fit;
	double p;
	double [] Pos;
	int dim,x,y;
	double xMax;
	Bee Beelist[];
	int worldXSize, worldYSize,beeType;
	MapSpace mapSpace;
	Grid2d world;
	
	public Bee(Zone aZone,Grid2d w,MapSpace f,double xm,int d,Bee[] list,Random rnd){
		super(aZone);
		world=w;
		mapSpace=f;
		dim=d;
		xMax=xm;
		Beelist=list;
		fit=0;
		setWorldSizeX$Y(world.getSizeX(),world.getSizeY());
		Pos=new double[dim];
		initialize(rnd);
		setBeeType(1);
	}
	
	public void initialize(Random rnd){
		int i;
		for (i=0;i<dim;i++){
			Pos[i]=2*xMax*rnd.nextDouble()-xMax;
		}
		setPos(Pos);
	}

	public Object setPos(double po[]){
		xPos = po[0];
		yPos = po[1];
		x=(int)(worldXSize/2+xPos*worldXSize/xMax/2);
		if (x<0) x=0;
		if (x>=worldXSize) y=worldXSize-1; 
		y=(int)(worldYSize/2+yPos*worldYSize/xMax/2);
		if (y<0) y=0;
		if (y>=worldYSize) y=worldYSize-1;
		if (world.getObjectAtX$Y(x,y) == null){
			world.putObject$atX$Y(this,x,y);
		}
		Pos=po;
		resets();
		return this;
	}

	public Object setWorldSizeX$Y(int xSize, int ySize){
		worldXSize=xSize;
		worldYSize=ySize;
		return this;
	}
	
	public double[] getPos(){
		return Pos;
	}
	
	public int gets(){
		return s;
	}
	
	public void resets(){
		s=0;
	}
	
	public void adds(){
		s++;
	}
	
	public void setp(double a){
		p=a;
	}
	
	public double getp(){
		return p;
	}
	
	public void setf(double a){
		fit=a;
	}
	
	public double getf(){
		return fit;
	}
	
	public void setBeeType(int i){
		//1:employed BeeA2:onlookersA3:scout
		beeType=i;
	}
	
	public Object drawSelfOn(Raster r){
		r.drawPointX$Y$Color(x,y,(byte)(beeType));
		return this;
	}

}
